
# $Id: Onasys.py,v 1.6 2006/05/08 20:26:58 bmoe Exp $

from HTMLgen import *
from HTMLgen.cgiapp import MinimalCGI
from HTMLgen.HTMLgen import CONTYPE, DOCTYPE
from HTMLgen.HTMLgen import TableLite, BR, TR, TD, Image, Href, Paragraph, HR, Font

class OnasysDocument(MinimalCGI):

    nav = ""
    navGutterWidth = 30

    def header(self):
        return """
        <table>
                <tr>
                   <td>
                        <a href="%s"><img src="%s" alt="%s" border="0"></a>
                   </td>
                   <td>
                        <h1>%s &mdash; %s</h1>
                   </td>
                </tr>
        </table>
        <hr>
        """ % (self.baseCGIRef, self.logo, self.logoalt, self.bodytitle, self.site)

    def footer(self):
        br = str(BR())
        hatLink = Href("http://www.metmuseum.org/special/Jacqueline_Kennedy/Kennedy_images.htm", "Pillbox Hat, 1961", target='_new')
        copyright = "Bergdorf Goodman (est. 1901)" + br + \
                    "Beige felt" + br + \
                    "Worn by Jacqueline Kennedy to the Inauguration Ceremony,"+\
                    " Washington, D.C., January 20, 1961" + br + \
                    "John F. Kennedy Library and Museum"
        f = Paragraph(HR())
        link = "Copyright &copy; 2000&ndash;2005 " + \
               str(Href("http://www.metmuseum.org", \
                        "The Metropolitan Museum of Art", target='_new')) + \
               ". All rights reserved."

        f.append(Font(hatLink, size=-2))
        f.append(BR())
        f.append(Font(copyright, size=-2, html_escape="OFF"))
        f.append(BR())
        f.append(Font(link, size=-2, html_escape="OFF"))
        return str(f)
        #return "<hr><i>Footer</i>"

    def sidenav(self):
        t = TableLite()
        r = TR()
        r.append(TD(self.spacerImage(valign='top', width=1, height=400)), TD(self.nav, valign='top'))
        t.append(r)
        return str(t)
        return str(self.nav)

    def spacerImage(self, **kw):
        return Image(self.spacer, self.spacer, **kw)

    def __str__(self):
        s = []
        if self.cgi:
            s.append(CONTYPE + DOCTYPE)
        else:
            s.append(DOCTYPE)

        # build the HEAD and BODY tags
        s.append(self.html_head())
        s.append(self.html_body_tag())
        # HEADER SECTION
        s.append(self.header())
                                                                          
        body = TableLite()
        bodyRow = TR()
        sideNavCol = TD(self.sidenav(), valign="top", html_escape="NO")
        gutterCol = TD(self.spacerImage(width=self.navGutterWidth, height=1, html_escape="NO"))
        contentCol = TD(("%s\n"*len(self.contents)) % tuple(self.contents), valign='top', html_escape="NO")
        bodyRow.append(sideNavCol)
        bodyRow.append(gutterCol)
        bodyRow.append(contentCol)
        body.append(bodyRow)

        s.append(str(body))
                                                                          
        s.append(self.footer())
        s.append('\n</BODY> </HTML>\n') # CLOSE the document
        return ''.join(s)

